Index: trunk/lib/FlairSensorActuator/src/V4LCamera.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/V4LCamera.cpp	(revision 351)
+++ trunk/lib/FlairSensorActuator/src/V4LCamera.cpp	(revision 352)
@@ -17,21 +17,10 @@
 
 #include "V4LCamera.h"
-#include <GroupBox.h>
-#include <DoubleSpinBox.h>
-#include <CheckBox.h>
-#include <Label.h>
+#include "V4LCamera_impl.h"
 #include <Image.h>
 #include <FrameworkManager.h>
-#include <fcntl.h>
-//#include <linux/videodev2.h>
-#include <sys/ioctl.h>
-#include <unistd.h>
-#include <cstring>
-#include <sys/mman.h>
-#include <VisionFilter.h>
 
 using std::string;
 using namespace flair::core;
-using namespace flair::gui;
 
 namespace flair {
@@ -43,266 +32,16 @@
       Camera(name, width, height, format) {
   
-  string deviceName="/dev/video"+std::to_string(camera_index);
-  device = open(deviceName.c_str(), O_RDWR | O_NONBLOCK);
-  if (device == -1) {
-      Thread::Err("Cannot open %s\n",deviceName.c_str());
-  } else {
-      Printf("V4LCamera %s, opened %s\n",name.c_str(),deviceName.c_str());
-  }
-
-  if(format == Image::Type::Format::UYVY) {
-    if(Init(width,height,V4L2_PIX_FMT_UYVY) == -1) {
-     Thread::Err("initialisation failed\n");
-    }
-  } else if (format == Image::Type::Format::YUYV) {
-    if(Init(width,height,V4L2_PIX_FMT_YUYV) == -1) {
-     Thread::Err("initialisation failed\n");
-    }
-  } else {
-    Thread::Err("format not supported\n");
-  }
-  
-  //todo: better handling of detection, only neeeded for omap/dm
-  //also in run, copy from v4l to cmem is not necessary if not using cmem...
-#ifdef ARMV7A
-  useMemoryUsrPtr=true;
-#else
-  useMemoryUsrPtr=false;
-#endif
-  if(useMemoryUsrPtr) {
-    AllocUserBuffers();
-  } else {
-    AllocV4LBuffers();
-  }
-  
-  for (int i=0;i < nbBuffers;i++) {
-    QueueBuffer(i);
-  }
-
-  /* enable the streaming */
-  v4l2_buf_type type;
-  type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-  if (-1 == xioctl (device, VIDIOC_STREAMON,&type)) {
-    Thread::Err("VIDIOC_STREAMON error\n");
-  }
-  
-  // ground station
-  gain = new DoubleSpinBox(GetGroupBox()->NewRow(), "gain:", 0, 1, 0.1);
-  exposure = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "exposure:", 0,1, 0.1);
-  bright = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "bright:", 0, 1, 0.1);
-  contrast = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "contrast:", 0,1, 0.1);
-  hue = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "hue:", 0, 1, 0.1);
-  sharpness = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "sharpness:", 0, 1, 0.1);
-  sat = new DoubleSpinBox(GetGroupBox()->LastRowLastCol(), "saturation:", 0, 1,0.1);
-  autogain = new CheckBox(GetGroupBox()->NewRow(), "autogain:");
-  autoexposure = new CheckBox(GetGroupBox()->LastRowLastCol(), "autoexposure:");
-  awb = new CheckBox(GetGroupBox()->LastRowLastCol(), "awb:");
-  fps = new Label(GetGroupBox()->NewRow(), "fps");
-
-  hasProblems=false;
+  pimpl_=new V4LCamera_impl(this,name,camera_index,width,height,format);
 }
 
 V4LCamera::~V4LCamera() {
-  if(useMemoryUsrPtr) {
-    for (int i = 0; i < nbBuffers; i++) {
-      FreeFunction((char*)buffers[i]);
-    }
-  } else {
-      FreeFunction(imageData);
-  }
   SafeStop();
   Join();
-  close(device);
-}
-
-int V4LCamera::Init(int width, int height,unsigned long colorspace) {
-  struct v4l2_capability cap;
-  memset(&cap, 0, sizeof (v4l2_capability));
-  
-  if(-1 == xioctl(device, VIDIOC_QUERYCAP, &cap)) {
-    return -1;
-  }
-     
-  if ((cap.capabilities & V4L2_CAP_VIDEO_CAPTURE) == 0) {
-    Thread::Err("device is unable to capture video memory.\n");
-    return -1;
-  }
-
-  struct v4l2_format form;
-  memset(&form, 0, sizeof (v4l2_format));
-  form.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-
-  /* read the current setting */
-  if(-1 == xioctl(device, VIDIOC_G_FMT, &form)) {
-   Thread::Err("Could not obtain specifics of capture window.\n");
-   return -1;
-  }
-
-  /* set the values we want to change */
-  form.fmt.pix.width = width; 
-  form.fmt.pix.height = height;
-  form.fmt.win.chromakey = 0;
-  form.fmt.win.field = V4L2_FIELD_ANY;
-  form.fmt.win.clips = 0;
-  form.fmt.win.clipcount = 0;
-  form.fmt.pix.field = V4L2_FIELD_ANY;
-  form.fmt.pix.pixelformat = colorspace;
-
-  /* ask the device to change the size*/
-  if(-1 == xioctl (device, VIDIOC_S_FMT, &form)) {
-    Thread::Err("Could not set specifics of capture window.\n");
-    return -1;
-  }
-  
-  return 0;
-}
-
-int V4LCamera::AllocV4LBuffers() {
-  struct v4l2_requestbuffers req;
-  memset(&req, 0, sizeof (v4l2_requestbuffers));
-  nbBuffers=DEFAULT_V4L_BUFFERS;
-
-  try_again:
-
-  req.count = nbBuffers;
-  req.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-  req.memory = V4L2_MEMORY_MMAP;
-
-  if(-1 == xioctl(device, VIDIOC_REQBUFS, &req)) {
-    if (EINVAL == errno) {
-      Thread::Err("camera does not support memory mapping\n");
-    } else {
-      Thread::Err("VIDIOC_REQBUFS failed\n");
-    }
-    return -1;
-  }
-
-  if(req.count < nbBuffers) {
-    if (nbBuffers == 1) {
-      Thread::Err("Insufficient buffer memory\n");
-      return -1;
-    } else {
-      nbBuffers--;
-      Thread::Warn("Insufficient buffer memory -- decreaseing buffers to %i\n",nbBuffers);
-      goto try_again;
-    }
-  }
-
-  for(int i=0; i<req.count; i++) {
-    struct v4l2_buffer buf;
-    memset(&buf, 0, sizeof (v4l2_buffer));
-
-    buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-    buf.memory = V4L2_MEMORY_MMAP;
-    buf.index = i;
-
-    if(-1 == xioctl(device, VIDIOC_QUERYBUF, &buf)) {
-      Thread::Err("VIDIOC_QUERYBUF error\n");
-      return -1;
-    }
-
-    if(output->GetDataType().GetSize()!=buf.length) {
-      Thread::Err("buf size is not as exepcted %i/%i\n",buf.length,output->GetDataType().GetSize());
-      return -1;
-    }
-
-    buffers[i]=mmap(NULL,buf.length,PROT_READ | PROT_WRITE,MAP_SHARED,device, buf.m.offset);
-
-    if(MAP_FAILED == buffers[i]) {
-      Thread::Err("mmap error\n");
-      return -1;
-    }
-  }
-
-  //allocate output data
-  imageData = AllocFunction(output->GetDataType().GetSize());
-  //Printf("cmem allocated %i at %x\n",output->GetDataType().GetSize(),imageData);
-
-  return 1;
-};
-
-int V4LCamera::AllocUserBuffers(void) {
-  struct v4l2_requestbuffers req;
-  memset(&req, 0, sizeof (v4l2_requestbuffers));
-  nbBuffers=DEFAULT_V4L_BUFFERS;
-
-  req.count = nbBuffers;
-  req.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-  req.memory = V4L2_MEMORY_USERPTR;
-
-  if (xioctl (device, VIDIOC_REQBUFS, &req)==-1) {
-    if (errno==EINVAL) {
-      Thread::Err("VIDIOC_REQBUFS user memory not supported\n");
-    } else {
-      Thread::Err ("VIDIOC_REQBUFS xioctl\n");
-    }
-    return -1;
-  }
-
-  for (int i=0; i<nbBuffers; i++) {
-    buffers[i] =AllocFunction(output->GetDataType().GetSize());
-  }
-
-  return 1;
-};
-
-int V4LCamera::GrabFrame(void) {
-  fd_set fds;
-  struct timeval tv;
-  FD_ZERO (&fds);
-  FD_SET (device, &fds);
-
-  tv.tv_sec = 0;
-  tv.tv_usec = 100000;
-
-  int r=select(device+1, &fds, NULL, NULL, &tv);
-
-  if (r==-1) {
-    char errorMsg[256];
-    Thread::Err("select (%s)\n", strerror_r(-r, errorMsg, sizeof(errorMsg)));
-    return -1;
-  }
-
-  if (r==0) {
-    Thread::Err("select timeout\n");
-    return -1;
-  }
-  
-  struct v4l2_buffer buf;
-  memset(&buf, 0, sizeof (v4l2_buffer));
-  buf.type=V4L2_BUF_TYPE_VIDEO_CAPTURE;
-  if(useMemoryUsrPtr) {
-    buf.memory=V4L2_MEMORY_USERPTR;
-  } else {
-    buf.memory=V4L2_MEMORY_MMAP;
-  }
-
-   //get last captured buffer
-  dQueuedBuffer.index=-1;
-  for(int i=0;i<nbBuffers;i++) {
-    if (xioctl (device, VIDIOC_DQBUF, &buf)==-1) {
-      if (errno==EAGAIN) {//when no new buffer is available for reading (non blocking)
-        //Printf("%s eagain\n",Thread::ObjectName().c_str());
-        break;
-      } else {
-        Thread::Err("VIDIOC_DQBUF xioctl\n");
-        return -1;
-      }
-    } else {
-      //Printf("%s %i dqueued\n",Thread::ObjectName().c_str(),buf.index);
-      //Printf("%i %x %i %i\n",buf.bytesused,buf.flags,buf.field,buf.sequence);
-      if(dQueuedBuffer.index!=-1) {
-        //Printf("%s %i queued\n",Thread::ObjectName().c_str(),dQueuedBuffer.index);
-        QueueBuffer(&dQueuedBuffer);
-      }
-      dQueuedBuffer=buf;
-    }
-  }
-  //Printf("%s %i\n",Thread::ObjectName().c_str(),dQueuedBuffer.index);
-
-  return 1;
+  delete pimpl_;
 }
 
 void V4LCamera::Run(void) {
+  pimpl_->Run();
+  /*
   Time cam_time, new_time, fpsNow, fpsPrev;
   int fpsCounter = 0;
@@ -368,14 +107,5 @@
       Thread::Warn("delta t trop grand\n");
       hasProblems=true;
-    }/*
-    if(hasProblems==false) {
-      struct v4l2_format form;
-      form.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-      xioctl(device, VIDIOC_G_FMT,&form);
-      if(xioctl (device, VIDIOC_G_FMT,&form)<0) {
-        Thread::Warn("camera disconnected\n");
-        hasProblems=true;
-      }
-    }*/
+    }
 
     //select buffer
@@ -400,39 +130,13 @@
     }
   }
-}
-
-int V4LCamera::QueueBuffer(struct v4l2_buffer *buf) {
-  if(buf->index>=0 && buf->index<nbBuffers) {
-    int ret=xioctl (device, VIDIOC_QBUF,buf);
-    if (ret==-1) {
-      Thread::Err("VIDIOC_QBUF xioctl %s\n",strerror(-ret));
-      return -1;
-    }
-  }
-  return 0;
-}
-
-int V4LCamera::QueueBuffer(int index) {
-  struct v4l2_buffer buf;
-  memset(&buf, 0, sizeof (v4l2_buffer));
-  
-  buf.type=V4L2_BUF_TYPE_VIDEO_CAPTURE;
-  buf.index=(unsigned long)index;
-  if(useMemoryUsrPtr) {
-    buf.memory=V4L2_MEMORY_USERPTR;
-    buf.m.userptr=(unsigned long)(buffers[index]);
-    buf.length=output->GetDataType().GetSize();
-  } else {
-    buf.memory=V4L2_MEMORY_MMAP;
-  }
-  return QueueBuffer(&buf);
+   */
 }
 
 bool V4LCamera::HasProblems(void) {
-  return hasProblems;
+  return pimpl_->hasProblems;
 }
 
 void V4LCamera::SetAutoGain(bool value) {
-  SetProperty(V4L2_CID_AUTOGAIN, value);
+  pimpl_->SetAutoGain(value);
 }
 
@@ -442,71 +146,25 @@
 
 void V4LCamera::SetGain(float value) {
-  SetProperty(V4L2_CID_GAIN, value);
+  pimpl_->SetGain(value);
 }
 
 void V4LCamera::SetExposure(float value) {
-  SetProperty(V4L2_CID_EXPOSURE, value);
+  pimpl_->SetExposure(value);
 }
 
 void V4LCamera::SetBrightness(float value) {
-  SetProperty(V4L2_CID_BRIGHTNESS, value);
+  pimpl_->SetBrightness(value);
 }
 
 void V4LCamera::SetSaturation(float value) {
-  SetProperty(V4L2_CID_SATURATION, value);
+  pimpl_->SetSaturation(value);
 }
 
 void V4LCamera::SetHue(float value) {
-  SetProperty(V4L2_CID_HUE, value);
+  pimpl_->SetHue(value);
 }
 
 void V4LCamera::SetContrast(float value) {
-  SetProperty(V4L2_CID_CONTRAST, value);
-}
-
-float V4LCamera::GetProperty(int property) {
-  //get min and max value
-  struct v4l2_queryctrl queryctrl;
-  queryctrl.id = property;
-  if(xioctl (device, VIDIOC_QUERYCTRL,&queryctrl)==-1) return -1;
-  int min = queryctrl.minimum;
-  int max = queryctrl.maximum;
- 
-  //set value
-  struct v4l2_control control;
-  memset (&control, 0, sizeof (v4l2_control));
-  control.id = property;
-  if(xioctl (device,VIDIOC_G_CTRL, &control)==-1) return -1;
-  
-  return ((float)control.value - min + 1) / (max - min);
-}
-
-void V4LCamera::SetProperty(int property,float value) {
-  //get min and max value
-  struct v4l2_queryctrl queryctrl;
-  queryctrl.id = property;
-  if(xioctl (device, VIDIOC_QUERYCTRL,&queryctrl)==-1) {
-    Thread::Warn("prop %x, VIDIOC_QUERYCTRL failed\n",property);
-  }
-  int min = queryctrl.minimum;
-  int max = queryctrl.maximum;
- 
-  //set value
-  struct v4l2_control control;
-  memset (&control, 0, sizeof (v4l2_control));
-  control.id = property;
-  control.value = (int)(value * (max - min) + min);
-  if(xioctl (device,VIDIOC_S_CTRL, &control)==-1) {
-    Thread::Warn("prop %x, VIDIOC_S_CTRL failed\n",property);
-  }
-}
-
-int V4LCamera::xioctl( int fd, int request, void *arg) {
-  int r;
-
-  do r = ioctl (fd, request, arg);
-  while (-1 == r && EINTR == errno);
-
-  return r;
+  pimpl_->SetContrast(value);
 }
 