Index: trunk/demos/OpticalFlow/uav/resources/armv7a-neon/OpticalFlow_ardrone2.xml
===================================================================
--- trunk/demos/OpticalFlow/uav/resources/armv7a-neon/OpticalFlow_ardrone2.xml	(revision 353)
+++ trunk/demos/OpticalFlow/uav/resources/armv7a-neon/OpticalFlow_ardrone2.xml	(revision 354)
@@ -43,5 +43,5 @@
           <GroupBox name="Vz">
             <DoubleSpinBox name="period, 0 for auto:" value="0"/>
-          </GroupBox>
+          <DoubleSpinBox name="saturation, -1 to disable:" value="-1"/></GroupBox>
           <GroupBox name="Passe bas v">
             <DoubleSpinBox name="period, 0 for auto" value="0"/>
@@ -58,5 +58,5 @@
       <TabWidget name="parrot-imu">
         <Tab name="Reglages">
-          <GroupBox name="parrot-imu"/>
+          <GroupBox name="parrot-imu"><CheckBox name="enable magnetometer (send 0 if unchecked):" value="0"/><Vector3DSpinBox name="magnetic offset (uT)" value_x="0" value_y="0" value_z="0"/><GroupBox name="magnetometers transformation"><DoubleSpinBox name="0,0" value="1"/><DoubleSpinBox name="0,1" value="0"/><DoubleSpinBox name="0,2" value="0"/><DoubleSpinBox name="1,0" value="0"/><DoubleSpinBox name="1,1" value="1"/><DoubleSpinBox name="1,2" value="0"/><DoubleSpinBox name="2,0" value="0"/><DoubleSpinBox name="2,1" value="0"/><DoubleSpinBox name="2,2" value="1"/></GroupBox></GroupBox>
           <GroupBox name="post rotation">
             <DoubleSpinBox name="value" value="0"/>
@@ -69,5 +69,5 @@
           <DoubleSpinBox name="k_b[1]:" value="0.01"/>
           <DoubleSpinBox name="k_b[2]:" value="0.01"/>
-        </Tab>
+        <DoubleSpinBox name="ka[0]:" value="0.5"/><DoubleSpinBox name="ka[1]:" value="0.5"/><DoubleSpinBox name="ka[2]:" value="0"/><DoubleSpinBox name="kb[0]:" value="0.01"/><DoubleSpinBox name="kb[1]:" value="0.01"/><DoubleSpinBox name="kb[2]:" value="0.01"/><DoubleSpinBox name="km[0]:" value="0.01"/><DoubleSpinBox name="km[1]:" value="0.01"/><DoubleSpinBox name="km[2]:" value="0.01"/><Vector3DSpinBox name="ref magnetic field (uT)" value_x="20.5324001312256" value_y="0.236699998378754" value_z="43.6682014465332"/></Tab>
         <Tab name="AHRS">
           <DataPlot1D name="roll" period="100" enabled="0"/>
@@ -89,5 +89,5 @@
           <DataPlot1D name="mag_z" period="100" enabled="0"/>
         </Tab>
-      </TabWidget>
+      <Tab name="Quaternion"><DataPlot1D name="q0" period="100" enabled="0"/><DataPlot1D name="q1" period="100" enabled="0"/><DataPlot1D name="q2" period="100" enabled="0"/><DataPlot1D name="q3" period="100" enabled="0"/></Tab></TabWidget>
     </Tab>
     <Tab name="battery">
@@ -95,5 +95,5 @@
         <Label name="battery"/>
         <DoubleSpinBox name="threshold" value="10.5"/>
-      </GroupBox>
+      <SpinBox name="threshold time" value="10"/></GroupBox>
     </Tab>
     <Tab name="camv">
@@ -139,5 +139,5 @@
               <SpinBox name="nb points:" value="100"/>
             </GroupBox>
-          </GridLayout>
+          <GroupBox name="flux optique compense"><SpinBox name="gyro delay (in video frames):" value="2"/><DoubleSpinBox name="gyro gain:" value="300"/></GroupBox><GroupBox name="vitesse du Flux Optique"><DoubleSpinBox name="optical flow quality:" value="5"/><CheckBox name="Weighted average" value="1"/><CheckBox name="Time multiplication" value="1"/></GroupBox><GroupBox name="Speed lowPass"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="derivative"><DoubleSpinBox name="period, 0 for auto:" value="0"/><DoubleSpinBox name="saturation, -1 to disable:" value="-1"/></GroupBox><GroupBox name="Acceleration lowPass"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox></GridLayout>
         </Tab>
         <Tab name="Picture">
@@ -160,5 +160,5 @@
         <PushButton name="take_off"/>
         <PushButton name="land"/>
-      </GridLayout>
+      <PushButton name="start optical flow"/></GridLayout>
       <GroupBox name="takeoff/landing">
         <DoubleSpinBox name="desired takeoff altitude" value="0.7"/>
@@ -258,6 +258,6 @@
       <DataPlot1D name="x_velocity" period="100" enabled="1"/>
       <DataPlot1D name="y_velocity" period="100" enabled="1"/>
-    </Tab>
-  </TabWidget>
+    <DataPlot1D name="x speed (px/s)" period="100" enabled="0"/><DataPlot1D name="y speed (px/s)" period="100" enabled="0"/></Tab>
+  <Tab name="parrot-pressure"><TabWidget name="parrot-pressure"><Tab name="Setup"><GroupBox name="parrot-pressure"/></Tab><Tab name="Mesures"><DataPlot1D name="parrot-pressure" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="camh"><TabWidget name="camh"><Tab name="Setup"><GroupBox name="camh"><DoubleSpinBox name="gain:" value="0.50"/><DoubleSpinBox name="exposure:" value="0.50"/><DoubleSpinBox name="bright:" value="0.50"/><DoubleSpinBox name="contrast:" value="0.50"/><DoubleSpinBox name="hue:" value="0.50"/><DoubleSpinBox name="sharpness:" value="0.50"/><DoubleSpinBox name="saturation:" value="0.50"/><CheckBox name="autogain:" value="0"/><CheckBox name="autoexposure:" value="0"/><CheckBox name="awb:" value="0"/><Label name="fps"/></GroupBox><GridLayout name="setup"/></Tab></TabWidget></Tab><Tab name="real speed"><DataPlot1D name="x speed (m/s)" period="100" enabled="0"/><DataPlot1D name="y speed (m/s)" period="100" enabled="0"/><DataPlot1D name="x acceleration (m/s2)" period="100" enabled="0"/><DataPlot1D name="y acceleration (m/s2)" period="100" enabled="0"/></Tab></TabWidget>
   <TabWidget name="App_TabWidget">
     <Tab name="demo_line">
@@ -265,3 +265,3 @@
     </Tab>
   <Tab name="Drone_0"><PushButton name="save config on target" value="1"/></Tab></TabWidget>
-</root>
+<PushButton name="save config on target (Drone_0)" value="1"/></root>