Index: trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.xml
===================================================================
--- trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.xml	(revision 365)
+++ trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.xml	(revision 384)
@@ -74,5 +74,5 @@
     <DoubleSpinBox value="70" name="fov:"/>
    <Vector3DSpinBox name="position" value_x="0" value_y="0" value_z="0"/><Vector3DSpinBox name="direction" value_x="1.00" value_y="0.00" value_z="0.00"/><Vector3DSpinBox name="up" value_x="0.00" value_y="0.00" value_z="-1.00"/></Tab>
-  </TabWidget>
+  <Tab name="visual"><SpinBox name="arm color (R):" value="255"/><SpinBox name="arm color (G):" value="0"/><SpinBox name="arm color (B):" value="0"/></Tab></TabWidget>
  </Tab>
 <Tab name="x4_1">
@@ -147,5 +147,5 @@
     <DoubleSpinBox value="70" name="fov:"/>
    <Vector3DSpinBox name="position" value_x="0" value_y="0" value_z="0"/><Vector3DSpinBox name="direction" value_x="1.00" value_y="0.00" value_z="0.00"/><Vector3DSpinBox name="up" value_x="0.00" value_y="0.00" value_z="-1.00"/></Tab>
-  </TabWidget>
+  <Tab name="visual"><SpinBox name="arm color (R):" value="0"/><SpinBox name="arm color (G):" value="255"/><SpinBox name="arm color (B):" value="0"/></Tab></TabWidget>
  </Tab>
   </TabWidget>
Index: trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.xml
===================================================================
--- trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.xml	(revision 365)
+++ trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.xml	(revision 384)
@@ -16,5 +16,5 @@
     <DoubleSpinBox value="-1.2" name="z:"/>
     <SpinBox value="90" name="yaw (deg):"/>
-   <Vector3DSpinBox name="position" value_x="1.5" value_y="0.00" value_z="-1.00"/></Tab>
+   <Vector3DSpinBox name="position" value_x="1.5" value_y="0" value_z="-1"/></Tab>
    <Tab name="model">
     <DoubleSpinBox value="1.6" name="mass (kg):"/>
@@ -31,5 +31,5 @@
     <DoubleSpinBox value="0.72" name="sigma:"/>
     <DoubleSpinBox value="1" name="S:"/>
-   </Tab>
+   <SpinBox name="motor timeout:" value="100"/></Tab>
    <Tab name="us">
     <GroupBox name="position">
@@ -81,5 +81,5 @@
     <DoubleSpinBox value="70" name="fov:"/>
    </Tab>
-  </TabWidget>
+  <Tab name="visual"><SpinBox name="arm color (R):" value="255"/><SpinBox name="arm color (G):" value="0"/><SpinBox name="arm color (B):" value="0"/></Tab></TabWidget>
  </Tab>
  <Tab name="target">
@@ -103,4 +103,4 @@
   </TabWidget>
  </Tab>
-<Tab name="x8_1"><TabWidget name="tabs"><Tab name="sampling"><DoubleSpinBox name="Tech (s):" value="0.001"/></Tab><Tab name="optitrack"><CheckBox name="enabled" value="1"/></Tab><Tab name="init"><DoubleSpinBox name="x:" value="1.50"/><DoubleSpinBox name="y:" value="0.0"/><DoubleSpinBox name="z:" value="-1.2"/><SpinBox name="yaw (deg):" value="-90"/><Vector3DSpinBox name="position" value_x="-1.5" value_y="0.00" value_z="-1.00"/></Tab><Tab name="model"><DoubleSpinBox name="mass (kg):" value="1.6"/><DoubleSpinBox name="arm length (m):" value="0.2"/><DoubleSpinBox name="position G (m):" value="0"/><DoubleSpinBox name="k_mot:" value="0.001"/><DoubleSpinBox name="c_mot:" value="0.001"/><DoubleSpinBox name="f_air_vert:" value="0.01"/><DoubleSpinBox name="f_air_lat:" value="0.4"/><DoubleSpinBox name="j_roll:" value="0.006"/><DoubleSpinBox name="j_pitch:" value="0.006"/><DoubleSpinBox name="j_yaw:" value="0.1"/><DoubleSpinBox name="j_r:" value="0"/><DoubleSpinBox name="sigma:" value="0.72"/><DoubleSpinBox name="S:" value="1"/></Tab><Tab name="us"><GroupBox name="position"><DoubleSpinBox name="x:" value="0"/><DoubleSpinBox name="y:" value="0"/><DoubleSpinBox name="z:" value="0.04"/></GroupBox><GroupBox name="direction"><DoubleSpinBox name="x:" value="0"/><DoubleSpinBox name="y:" value="0"/><DoubleSpinBox name="z:" value="1"/></GroupBox><DoubleSpinBox name="range:" value="6"/><Vector3DSpinBox name="position" value_x="0" value_y="0" value_z="0.0399999991059303"/><Vector3DSpinBox name="direction" value_x="0" value_y="0" value_z="1"/></Tab></TabWidget></Tab></TabWidget>
+<Tab name="x8_1"><TabWidget name="tabs"><Tab name="sampling"><DoubleSpinBox name="Tech (s):" value="0.001"/></Tab><Tab name="optitrack"><CheckBox name="enabled" value="1"/></Tab><Tab name="init"><DoubleSpinBox name="x:" value="1.50"/><DoubleSpinBox name="y:" value="0.0"/><DoubleSpinBox name="z:" value="-1.2"/><SpinBox name="yaw (deg):" value="-90"/><Vector3DSpinBox name="position" value_x="-1.5" value_y="0" value_z="-1"/></Tab><Tab name="model"><DoubleSpinBox name="mass (kg):" value="1.6"/><DoubleSpinBox name="arm length (m):" value="0.2"/><DoubleSpinBox name="position G (m):" value="0"/><DoubleSpinBox name="k_mot:" value="0.001"/><DoubleSpinBox name="c_mot:" value="0.001"/><DoubleSpinBox name="f_air_vert:" value="0.01"/><DoubleSpinBox name="f_air_lat:" value="0.4"/><DoubleSpinBox name="j_roll:" value="0.006"/><DoubleSpinBox name="j_pitch:" value="0.006"/><DoubleSpinBox name="j_yaw:" value="0.1"/><DoubleSpinBox name="j_r:" value="0"/><DoubleSpinBox name="sigma:" value="0.72"/><DoubleSpinBox name="S:" value="1"/><SpinBox name="motor timeout:" value="100"/></Tab><Tab name="us"><GroupBox name="position"><DoubleSpinBox name="x:" value="0"/><DoubleSpinBox name="y:" value="0"/><DoubleSpinBox name="z:" value="0.04"/></GroupBox><GroupBox name="direction"><DoubleSpinBox name="x:" value="0"/><DoubleSpinBox name="y:" value="0"/><DoubleSpinBox name="z:" value="1"/></GroupBox><DoubleSpinBox name="range:" value="6"/><Vector3DSpinBox name="position" value_x="0" value_y="0" value_z="0.0399999991059303"/><Vector3DSpinBox name="direction" value_x="0" value_y="0" value_z="1"/></Tab><Tab name="visual"><SpinBox name="arm color (R):" value="0"/><SpinBox name="arm color (G):" value="255"/><SpinBox name="arm color (B):" value="0"/></Tab></TabWidget></Tab></TabWidget>
 <TabWidget name="App_TabWidget"><Tab name="simulator"><PushButton name="save config on target" value="1"/></Tab></TabWidget><PushButton name="save config on target (simulator)" value="1"/></root>